#!/usr/bin/perl -w -i

use strict;
use IO::Handle;

my $id=1;

sub hd {
    my $t = $_[0];
    $t =~ s/&lt;/</g;
    $t =~ s/&gt;/>/g;
    $t =~ s/&amp;/&/g;
    return $t;
}

sub remove_underline {
    my $t = $_[0];
    $t =~ s!_!!g;
    return $t;
}

sub print_image {
    if(m!^(\s*<widget class="GtkImage" id="image)\d+(">.*)!) {
	print $1.($id++).$2."\n";
    } else {
	print;
    }
}

while(<>) {
    if(/"GtkMenuBar"/) {
	print;

	my @menustack = ("menubar");
	my $state = 0;
	while(<>) {
	    if($state == 0) {
		print_image;
		if(m!<widget.*"Gtk[A-Za-z]*MenuItem"!) {
		    $state = 1;
		    #print "$. $#menustack state = 1\n";
		} elsif(m!<widget!) {
		    push @menustack, "-";
		    #print "$. $#menustack dummy\n";
		} elsif(m!</widget>!) {
		    #print "$. $#menustack pop\n";
		    my $x = pop @menustack;
		    #print "$. $#menustack /wid $x\n";
		    last if($#menustack == -1);
		}
	    } elsif($state == 1) {
		if(m!^(.*<property name="label")[^>]*>([^<]+)</property>!) {
		    #print "$. $#menustack yeah $2\n";
		    my $prefix = $1;
		    my $text = $2;
		    if($text =~ /^gtk-/) {
			print $prefix.">".$text."</property>\n";
			$text =~ s!^gtk-!!;
			$text =~ s!-! !g;
			push @menustack, hd($text);
		    } else {
			print $prefix.' translatable="yes" comments="'.join(" / ", grep { $_ ne "-" } @menustack).'">'.$text."</property>\n";
			push @menustack, remove_underline(hd($text));
		    }
		    #print "$. $#menustack push : $text\n";
		    #print "$. $#menustack state = 0\n";
		    $state = 0;
		} elsif(m!</widget>!) {
		    print;
#		    #print "$. $#menustack pop $menustack[$#menustack]\n";
#		    last if($#menustack == -1);
#		    my $x = pop @menustack;
#		    #print "$. $#menustack /wid $x\n";
		    #print "$. $#menustack state = 0\n";
		    $state = 0;
		} else {
		    print_image;
		}
	    }
	}

	#print "/menu\n";

    } else {
	print_image;
    }
}
