/*
 * Plot - plot time-based data on screen and to file with interactive controls
 * Copyright (C) 2006  Jonas Berlin <xkr47@outerspace.dyndns.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 ****
 * eventhandlers - gtk event handlers, mostly calls other methods to
 * do the job
 */

#include <gtk/gtkcombobox.h>
#include <gtk/gtkdialog.h>
#include <gtk/gtkversion.h>

#include "../system.xh"
#include "plot2-datafiles.xh"
#include "remove_data_file_dialog.xh"

void remove_data_file_dialog_run(my_plot_t *plot) {
   GladeXML *gladexml = glade_xml_new(plot->gladefile, "dialog_remove_datafile", NULL);
   GtkWidget *dialog = glade_xml_get_widget(gladexml, "dialog_remove_datafile");

   GtkWidget *combo = glade_xml_get_widget(gladexml, "combobox_datafiles");

   gtk_combo_box_remove_text(GTK_COMBO_BOX(combo), 0);

   for(int lsi=0; lsi<plot->view[0]->draw.line_set_count; ++lsi) {
      gtk_combo_box_append_text(GTK_COMBO_BOX(combo), plot->view[0]->draw.line_set[lsi].dataset->path_utf8);
   }

   if(gtk_dialog_run(GTK_DIALOG(dialog)) == GTK_RESPONSE_OK) {
      gtk_widget_hide(dialog);

      int idx = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));
      if(idx >= 0) {
	 printf(_c("removing %d. %s\n"), idx, plot->view[0]->draw.line_set[idx].dataset->path_system);
	 remove_data_file(plot, idx);
      }
   }

   gtk_widget_destroy(dialog);
}

/*
 * Local variables:
 * c-file-style: "ellemtel"
 * c-file-offsets: ((c . c-lineup-dont-change) (statement-cont . (lambda (le) (if (save-excursion (goto-char (cdr le)) (looking-at "return")) (c-lineup-java-inher le) (c-lineup-math le)))))
 * End:
 */
